<!DOCTYPE html>
<html>
<head>
  <title>PRODUCT</title>
  <!-- Include Bootstrap CSS -->
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
</head>
<body>
	  <div class="container">
		<h1>PRODUCT</h1>
		<button class="btn btn-primary" data-bs-toggle="modal" data-bs-target="#addProductModal">Add New Product</button>
		<table class="table" id="myTable">
		  <thead>
			<tr>
			  <th>Code</th>
			  <th>Name</th>
			  <th>Category</th>
			  <th>Brand</th>
			  <th>Type</th>
			  <th>Description</th>
			  <th>Action</th>
			</tr>
		  </thead>
		  <tbody id="tableBody"></tbody>
		</table>
		<nav>
		  <ul class="pagination" id="pagination"></ul>
		</nav>
	  </div>
	
	<!-- Add Product Modal -->
	  <div class="modal fade" id="addProductModal" tabindex="-1" aria-labelledby="addProductModalLabel" aria-hidden="true">
		<div class="modal-dialog">
		  <div class="modal-content">
			<div class="modal-header">
			  <h5 class="modal-title" id="addProductModalLabel">Add New Product</h5>
			  <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
			</div>
			<div class="modal-body">
			  <form id="addProductForm">
				<div class="mb-3">
				  <label for="code" class="form-label">Code</label>
				  <input type="text" class="form-control" id="add-code" required>
				</div>
				<div class="mb-3">
				  <label for="name" class="form-label">Name</label>
				  <input type="text" class="form-control" id="add-name" required>
				</div>
				<div class="mb-3">
				  <label for="category" class="form-label">Category</label>
				  <select class="form-select" id="add-category" required>
					<option value="">Select a category</option>
				  </select>
				</div>
				<div class="mb-3">
				  <label for="brand" class="form-label">Brand</label>
				  <input type="text" class="form-control" id="add-brand" required>
				</div>
				<div class="mb-3">
				  <label for="type" class="form-label">Type</label>
				  <input type="text" class="form-control" id="add-type" required>
				</div>
				<div class="mb-3">
				  <label for="description" class="form-label">Description</label>
				  <textarea class="form-control" id="add-description" rows="3" required></textarea>
				</div>
				<div class="alert alert-danger d-none" role="alert" id="addProductErrorMessage">
					Error occurred while adding a new product.
				</div>
				<div class="modal-footer">
				  <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cancel</button>
				  <button type="submit" class="btn btn-primary">Add Product</button>
				</div>
			  </form>
			</div>
		  </div>
		</div>
	  </div>
	  
	  <!-- Edit Modal -->
	  <div class="modal fade" id="editModal" tabindex="-1" aria-labelledby="editModalLabel" aria-hidden="true">
		<div class="modal-dialog">
		  <div class="modal-content">
			<div class="modal-header">
			  <h5 class="modal-title" id="editModalLabel">Edit Product</h5>
			  <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
			</div>
			<div class="modal-body">
			  <!-- Form inputs go here -->
			  <form id="editForm">
				<div class="mb-3">
				  <label for="code" class="form-label">Code</label>
				  <input type="text" class="form-control" id="edit-code" readonly>
				</div>
				<div class="mb-3">
				  <label for="name" class="form-label">Name</label>
				  <input type="text" class="form-control" id="edit-name">
				</div>
				<div class="mb-3">
				  <label for="category" class="form-label">Category</label>
				  <select class="form-select" id="edit-category"></select>
				</div>
				<div class="mb-3">
				  <label for="brand" class="form-label">Brand</label>
				  <input type="text" class="form-control" id="edit-brand">
				</div>
				<div class="mb-3">
				  <label for="type" class="form-label">Type</label>
				  <input type="text" class="form-control" id="edit-type">
				</div>
				<div class="mb-3">
				  <label for="description" class="form-label">Description</label>
				  <textarea class="form-control" id="edit-description"></textarea>
				</div>
				<div class="modal-footer">
				  <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cancel</button>
				  <button type="submit" class="btn btn-primary">Add Product</button>
				</div>
			  </form>
			</div>
		  </div>
		</div>
	  </div>
	  
		<!-- Delete Confirmation Modal -->
		<div class="modal fade" id="deleteConfirmationModal" tabindex="-1" aria-labelledby="deleteConfirmationModalLabel" aria-hidden="true">
		  <div class="modal-dialog">
			<div class="modal-content">
			  <div class="modal-header">
				<h5 class="modal-title" id="deleteConfirmationModalLabel">Delete Confirmation</h5>
				<button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
			  </div>
			  <div class="modal-body">
				<p>Are you sure you want to delete this product?</p>
			  </div>
			  <div class="modal-footer">
				<button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cancel</button>
				<button type="button" class="btn btn-danger" id="deleteConfirmationButton">Delete</button>
			  </div>
			</div>
		  </div>
		</div>

  <!-- Include jQuery and Bootstrap JS -->
  <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM" crossorigin="anonymous"></script>
  <script>
    // Function to fetch data from REST API
    function fetchData(page) {
      $.ajax({
        url: 'http://localhost:8080/api/products/pagination?page=' + page, 
        type: 'GET',
        dataType: 'json',
        success: function(response) {
          console.log(response);
          renderTable(response.data);
          renderPagination(response.page, response.totalPage);
        },
        error: function() {
          console.log('Error occurred while fetching data.');
        }
      });
    }

    // Function to render table rows
    function renderTable(data) {
	  var tableBody = $('#tableBody');
	  tableBody.empty();

	  data.forEach(function(row) {
		var tr = $('<tr>');
		tr.append('<td>' + row.code + '</td>');
		tr.append('<td>' + row.name + '</td>');
		tr.append('<td>' + row.category + '</td>');
		tr.append('<td>' + row.brand + '</td>');
		tr.append('<td>' + row.type + '</td>');
		tr.append('<td>' + row.description + '</td>');
		
		// Edit button
		var editButton = $('<button>', {
		  class: 'btn btn-primary edit-btn',
		  text: 'Edit',
		  'data-code': row.code,
		  click: function() {
			var code = $(this).data('code');
			fetchProductData(code);
		  }
		});
		
		// Delete button
		var deleteButton = $('<button>', {
		  class: 'btn btn-danger delete-btn',
		  text: 'Delete',
		  'data-code': row.code,
		  click: function() {
			var code = $(this).data('code');
			showDeleteConfirmationModal(code);
		  }
		});
		
		
		var actionColumn = $('<td>').append(editButton, deleteButton);
		tr.append(actionColumn);
		
		tableBody.append(tr);
	  });
	}


    // Function to render pagination
    function renderPagination(currentPage, totalPage) {
      var pagination = $('#pagination');
      pagination.empty();

      // Previous button
      var previousLi = $('<li>', {
        class: 'page-item ' + (currentPage === 1 ? 'disabled' : ''),
      });
      var previousLink = $('<a>', {
        class: 'page-link',
        href: '#',
        text: 'Previous',
        'data-page': currentPage - 1,
      });
      previousLi.append(previousLink);
      pagination.append(previousLi);

      for (var i = 1; i <= totalPage; i++) {
        var li = $('<li>', {
          class: currentPage === i ? 'page-item active' : 'page-item'
        });
        var a = $('<a>', {
          class: 'page-link',
          href: '#',
          text: i,
          'data-page': i
        });
        li.append(a);
        pagination.append(li);
      }

      // Next button
      var nextLi = $('<li>', {
        class: 'page-item ' + (currentPage === totalPage ? 'disabled' : ''),
      });
      var nextLink = $('<a>', {
        class: 'page-link',
        href: '#',
        text: 'Next',
        'data-page': currentPage + 1,
      });
      nextLi.append(nextLink);
      pagination.append(nextLi);
    }

    // Event handler for pagination clicks
    $('#pagination').on('click', '.page-link', function(e) {
      e.preventDefault();
      var page = $(this).data('page');
      fetchData(page);
    });

    // Event handler for edit button clicks
    $('#tableBody').on('click', '.edit-btn', function() {
      var code = $(this).data('code');
      fetchProductData(code);
    });

        // Function to fetch product data for editing
    function fetchProductData(code) {
      $.ajax({
        url: 'http://localhost:8080/api/products/' + code, 
        type: 'GET',
        dataType: 'json',
        success: function(response) {
          console.log(response);
          populateEditForm(response.data);
          openEditModal();
        },
        error: function() {
          console.log('Error occurred while fetching product data.');
        }
      });
    }
	
	// Event handler for add product form submission
    $('#addProductForm').submit(function(e) {
	  e.preventDefault();
	  var code = $('#add-code').val();
	  var name = $('#add-name').val();
	  var category = $('#add-category').val();
	  var brand = $('#add-brand').val();
	  var type = $('#add-type').val();
	  var description = $('#add-description').val();

	  var requestData = {
		code: code,
		name: name,
		category: category,
		brand: brand,
		type: type,
		description: description
	  };

	  $.ajax({
		url: 'http://localhost:8080/api/products',
		type: 'POST',
		dataType: 'json',
		contentType: 'application/json',
		data: JSON.stringify(requestData),
		success: function(response) {
		  console.log(response);
		  
		  fetchData(1);
		  $('#addProductModal').modal('hide');
		},
		error: function() {
		  console.log('Error occurred while adding a new product.');
		  $('#addProductErrorMessage').removeClass('d-none');
		}
	  });
	});
	
	$('#addProductModal').on('hidden.bs.modal', function() {
	  $('#addProductForm')[0].reset(); // Reset the form fields
	  $('#addProductErrorMessage').addClass('d-none');
	});
	
    // Function to populate the edit form with product data
    function populateEditForm(data) {
	  $('#edit-code').val(data.code);
      $('#edit-name').val(data.name);
      $('#edit-category').val(data.category);
      $('#edit-brand').val(data.brand);
      $('#edit-type').val(data.type);
      $('#edit-description').val(data.description);
    }

    // Function to open the edit modal
    function openEditModal() {
      $('#editModal').modal('show');
    }

    $('#editForm').submit(function(e) {
	  e.preventDefault();
	  var code = $('#edit-code').val();
	  var name = $('#edit-name').val();
	  var category = $('#edit-category').val();
	  var brand = $('#edit-brand').val();
	  var type = $('#edit-type').val();
	  var description = $('#edit-description').val();

	  $.ajax({
		url: 'http://localhost:8080/api/products/' + code,
		type: 'PUT',
		dataType: 'json',
		headers: {
		  'Content-Type': 'application/json'
		},
		data: JSON.stringify({
		  code: code,
		  name: name,
		  category: category,
		  brand: brand,
		  type: type,
		  description: description
		}),
		success: function(response) {
		  console.log(response);
		  fetchData(1);
		  $('#editModal').modal('hide');
		},
		error: function() {
		  console.log('Error occurred while updating product data.');
		  $('#editModal .modal-body').append('<br><div class="alert alert-danger">Failed to update product data. Please try again.</div>');
		}
	  });
	});
	
	$('#editModal').on('hidden.bs.modal', function() {
	  $('#editModal .modal-body .alert').remove();
	});

    // Initial data fetch
    fetchData(1);
	
	// Function to fetch product categories
	function fetchProductCategories() {
	  $.ajax({
		url: 'http://localhost:8080/api/product-categories', 
		type: 'GET',
		dataType: 'json',
		success: function(response) {
		  console.log(response);
		  populateCategoryDropdown(response.data);
		},
		error: function() {
		  console.log('Error occurred while fetching product categories.');
		}
	  });
	}

	// Function to populate the category dropdown
	function populateCategoryDropdown(data) {
	  var categoryAddDropdown = $('#add-category');
	  var categoryEditDropdown = $('#edit-category');
	  categoryAddDropdown.empty();
	  categoryEditDropdown.empty();
		
	  data.forEach(function(category) {
		categoryAddDropdown.append($('<option>', {
		  value: category.id,
		  text: category.category
		}));
		categoryEditDropdown.append($('<option>', {
		  value: category.id,
		  text: category.category
		}));
	  });
	}

	// Call the fetchProductCategories function to populate the category dropdown initially
	fetchProductCategories();
	
	// Function to show the delete confirmation modal
	function showDeleteConfirmationModal(code) {
	  $('#deleteConfirmationModal').modal('show');
	  $('#deleteConfirmationModal').data('code', code); // Store the product code in the modal data
	}

	// Event handler for delete confirmation
	$('#deleteConfirmationButton').click(function() {
	  var code = $('#deleteConfirmationModal').data('code');
	  deleteProduct(code);
	});

	// Function to delete a product
	function deleteProduct(code) {
	  $.ajax({
		url: 'http://localhost:8080/api/products/' + code,
		type: 'DELETE',
		success: function(response) {
		  console.log(response);
		  fetchData(1);
		  $('#deleteConfirmationModal').modal('hide');
		},
		error: function() {
		  console.log('Error occurred while deleting product.');
		}
	  });
	}
  </script>
</body>
</html>


